# -*- coding: latin-1 -*-

from fuzzyLib import *
from mittLib import *
import time
import threading
import sys


class Musikkmaker(threading.Thread):
   
        def __init__(self,CsKontroll):
                threading.Thread.__init__(self)
                self.csound = CsKontroll
                self.lagmusikk  = False     #S lenge denne er True, kjres musikkmaker
                self.spill      = False     #S lenge denne er True spilles det lyd
                                            # benyttes kun for  sl av eller p csound ifm debugging
                                            # settes true av NNFrame ved Csound initiering

                self.avslutt = False        # Denne kan settes til true for  avslutte trden.
                self.initval()
                
                '''---Fuzzy sett---'''
                ### Predikater ###
                # Glad/rolig verdi  =     0,   10,  20,  30,  40,   50,  60,   70,  80,  90, 100
                self.erglad         =   [ 0.1, 0.2, 0.3, 0.4, 0.45, 0.5, 0.55, 0.6, 0.7, 0.9,  1 ]
                self.errolig        =   [ 0.1, 0.1, 0.2, 0.3, 0.4,  0.5, 0.6,  0.7, 0.8, 0.9,  1 ]
                # Toneverdi             [ 0,   10,  20,  30,  40,  50,  60,  70,  80,  90,  100, 110, 120,  130 ]
                self.forlyst        =   [ 0,   0,   0,   0,   0,   0,   0,   0.1, 0.3, 0.7, 0.9, 0.93, 0.95, 1  ]
                self.formorkt       =   [ 1,   1,   0.9, 0.8, 0.6, 0.3, 0.1, 0,   0,   0,   0,   0,    0,    0  ]
                # Ant p rad            [ 0,   1,   2,   3,   4,   5,   6,   7,   8    9    10]
                self.formangeparad  =   [ 0,   0,   0.3, 0.5, 0.7, 0.9, 1,   1,   1,   1,   1 ]
                # Hopp                  [ 0,   1,   2,   3,   4,   5,   6,   7,   8,   9,   10, 11, 12 ]
                self.korthopp       =   [ 0,   1,   0.9, 0.8, 0.2, 0.1, 0,   0,   0,   0,   0,  0,  0  ]
                
                ### Konsekvenser ###
                # Ant pa rad/ant hopp:  [ 0,   1,   2,   3,   4,   5,   6,   7,    8    9     10   11  12]
                self.spillmorkere   =   [ 0,   0.1, 0.2, 0.4, 0.5, 0.7, 0.8, 0.85, 0.8, 0.8,  0.9, 1,  1]
                self.spilllysere    =   [ 0,   0.1, 0.2, 0.4, 0.5, 0.7, 0.8, 0.85, 0.8, 0.8,  0.9, 1,  1]
                self.skiftretn      =   [ 0,   0,   0.1, 0.2, 0.3, 0.3, 0.5, 0.7,  0.9, 1,    1  ]
                self.scorevekt      =   [ 0,   0.2, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9,  1.0, 1.1,  1.2]
                # Deltone oppdeling     [ 0.125,  0.25,   0.5,    1,   2  ]
                self.merdeltoner    =   [ 1.0,    0.5,    0.2,    0.0, 0  ]
                self.spilltregere   =   [ 0.0,    0.0,    0.2,    0.4, 0.9]


                ##Skalaer
                # Tone fra grunntonen   [ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
                self.dur        =       [ 1, 0, 1, 0, 1, 1, 0, 1, 0, 1,  0, 1 ]
                self.moll       =       [ 1, 0, 1, 1, 0, 1, 0, 1, 1, 0,  0, 1 ]
                self.blues      =       [ 1, 0, 0, 1, 0, 1, 1, 1, 0, 0,  1, 0 ]
                '''---Fuzzy sett---'''

                # Hvliken skala som skal benyttes. Denne kan endres fra kontrollpanelet
                self.skalaibruk = self.dur
                
        def initval(self):
                # Startverdier
                self.toneart = 60                                   # Starter p en C
                self.noten   = self.toneart                         # Noten som spilles av
                self.tempo   = 120                                  # Tempoet i bpm
                self.tempoliste    = [0.125, 0.25, 0.5, 1, 2]       # Tempo oppdeling, fra 1/8 - 2
                self.glad    = 75                                   # Glad verdi
                self.rolig   = 30                                   # Rolig verdi
                self.parad   = 0                                    # Variabel for regel 2
                self.skiftglad = False                              # Variabel for regel 3
                self.gladparad = 0                                  # Variabel for regel 3
                self.huskglad  = self.glad                          # Variabel for regel 3
                self.tempoindex    = 3                              # Variabel for regel 12
                self.nestemaxindex = 4                              # Variabel for regel 12
                self.enTil   = False                                # Variabel for regel 12
                self.spilltick = -32
                self.nynotetid = 0
                self.spilltrommer = True
                self.tempoparad = 1
                self.historie = [self.toneart,self.toneart]         # Historie over alle avspilte noter
                                                                    # (starter med 2 verdier fordi reglene 
                                                                    # benytter seg av de siste 2 spilte notene)
                                                                    
                self.makescore = False                              # Settes true for  skrive ut
                self.starte = 0                                     # CSound score informasjon
                self.sco =[]                                        # til  lage wav fil av
        

        #Debug metode for a skrive ut verdier
        def vis(self):
                print 'Verdier: note', self.noten, 'tempo', self.tempo, 'glad', self.glad, 'rolig', self.rolig

        def nullstill(self):
            ''' Nullstiller variabler '''
            self.parad      = 0
            self.skiftglad  = False 
            self.gladparad  = 0
            self.huskglad   = self.glad
            self.tempoindex    = 3
            self.nestemaxindex = 4
            self.enTil   = False
            self.historie = [self.noten,self.noten]
            self.vis()
    
    

        def settNote(self,note,dur):
            """ Fr inn verdier fra NNFrame og setter hvilken toneart det spilles i """
            self.toneart = note
            self.noten = note
            if dur=="dur":
                self.skalaibruk = self.dur
            elif dur=="moll":
                self.skalaibruk = self.moll
            self.lagmusikk = True
            #print 'Lovlige noter',skiftListe(self.skalaibruk,self.toneart%12) 

        #Metode for  bestemme hvilken note som skal spilles
        def bestemnote(self):
                '''
                Implementasjon av nye regler legges her
                Fuzzy sett og variabler tilhrende reglene legges i __init__

                Utfrer reglene sekvensielt. Noten endres litt etter hver regel,
                og alle kandidatnoter fra hver regel legges i en nyenoter-liste.
                Deretter vektes score til kandidatene og til slutt spilles
                noten med hyest score som samtidig er en lovlig note

                Hver regel fr en vekt(settes i init) som score til kandidatnoter skaleres med.
                

                ------------------------  Regler  ------------------------

                ## Regler for noteverdi ##
                (Starter p regel 0 for  f konsistens med regel-liste index)
                Regler som gir nye kandidater:
                0. Hvis glad spill lysere
                1. Hvis for lyst spill mrkere, hvis for mrkt spill lysere
                2. Hvis for mange like toner/hopp p rad skift retning
                3. Dersom gladverdi er lik over en lang periode skift en liten stund
                

                Regler som vekter score til kandidatene:
                7. Favoriser korte hopp. Hvis langt hopp, gi lavere score
                8. Favoriser ulike noter (hvis "note er lik som forrige" gi mindre score)
                9. Hvis tonen er utenfor toneleiet sett score lik 0


                ## Regler for rytmikk

                10. Hvis rolig spill saktere
                11. Hvis glad, spill mer deltoner
                12. Kun lov med hele takter (dvs antall deltoner m g opp i 8/8)
                
                ------------------------  Regler  ------------------------
                '''
                
                ## Regel nummer 15 er for  sette om det skal produseres note eller ikke ##

                # Hvilke regler skal benyttes og hvilken vekt har de
                # Regel nummer:     [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15]
                self.regelvekt   =  [1,2,2,1,1,1,1,2,3,2,2, 1, 1, 1 ,0, 0] # Vekting for hver regel
                self.attedel = 1/(self.tempo/60.0)
                self.tick = 1/(8*self.tempo/60.0)
                
                #Spiller av nr det er tid for ny note
                if self.spilltick == self.nynotetid:
                    self.benyttregel =  [1,1,1,1,1,1,1,1,1,1,1, 1, 1, 1 ,0,1] # Hvilke regler som skal benyttes (1=true)
                else:
                    self.benyttregel =  [0,0,0,0,0,0,0,0,0,0,0,0,0,0 ,0,0] # Hvilke regler som skal benyttes (1=true)

                
                # Initialiserer noen variabler for toneutvalg:
                
                # lovlige noter utfra tonearten og skalaen som benyttes. Alle noter sjekkes mot denne ved modulo 12
                lovligenoter  = skiftListe(self.skalaibruk,self.toneart%12) 
                
                forrigenote = self.noten            # Forrige note som ble spilt av
                nyenoter    = []                    # Her legges nye kandidatnoter
                                                    #   en ny kandidat er <self.noten + nyenoter_verdi>
                notescore   = []                    # score til notene i nyenoter
                                                    #   verdien i notescore tilsvarer noten p samme index i nyenoter

                # Regel 0: Hvis glad spill lysere
                if self.benyttregel[0]:
                    gladnote    = fzRule((self.glad/10), self.erglad, self.spilllysere)
                    self.noten  = int(self.noten + (-6+ 18*max(gladnote))) 
                    nyenoter    += addlist(gladnote,18,-6)
                    notescore   += addlist(gladnote,self.regelvekt[0])

                # Regel 1: Hvis for lyst spill mrkere, hvis for mrkt spill lysere
                if self.benyttregel[1]:
                    if self.noten>60:
                        lysnotelist    = fzRule((self.noten/10), self.forlyst, self.spillmorkere)   
                        nylysnote   = max(lysnotelist)
                        multiplikator = fzFind(self.spillmorkere,nylysnote)* -2
                        nyenoter    += addlist(lysnotelist,multiplikator,self.noten-forrigenote)
                        notescore   += addlist(lysnotelist,self.regelvekt[1])
                        self.noten  = int(self.noten +nylysnote)
                    else:
                        lysnotelist    = fzRule((self.noten/10), self.formorkt, self.spilllysere)   
                        nylysnote   = max(lysnotelist)
                        multiplikator = fzFind(self.spilllysere,nylysnote)* 2
                        nyenoter    += addlist(lysnotelist,multiplikator,self.noten-forrigenote)
                        notescore   += addlist(lysnotelist,self.regelvekt[1])
                        self.noten  = int(self.noten +nylysnote)

                # Regel 2: Hvis for mange like toner/hopp p rad skift retning
                if self.benyttregel[2]:
                    l = len(self.historie)
                    if((self.historie[l-1]-self.historie[l-2])>0 and (self.historie[l-2]-self.historie[l-3])>0)\
                       or((self.historie[l-1]-self.historie[l-2])<0 and(self.historie[l-2]-self.historie[l-3])<0):
                        self.parad += 1
                    elif (forrigenote == self.historie[l-2]):
                        self.parad += 2
                    else:
                        self.parad = 0
                    forrigehopp = forrigenote-self.historie[l-2]
                    skift = fzRule(self.parad, self.formangeparad, self.skiftretn)
                    if forrigehopp==0:
                        if self.parad== 0:
                            forrigehopp =1
                        else:
                            forrigehopp= self.parad
                    nyenoter += addlist(skift,-forrigehopp*5,self.noten-forrigenote)
                    notescore += addlist(skift,self.regelvekt[2])
                    self.noten = int(round(self.noten -forrigehopp*skift[int(self.parad)]))
                    if(self.parad>8):
                        self.parad=0

    
                # Regel 3: Dersom gladverdi er lik over en lang periode skift en liten stund
                if self.benyttregel[3]:
                    if self.skiftglad==True:
                        self.gladparad -= 1
                        if self.gladparad < 5:
                            self.gladparad  = 0
                            self.skiftglad  = False
                            self.glad       = self.huskglad
                    else:
                        self.gladparad += 1
                        if self.gladparad > 10:
                            self.huskglad   = self.glad
                            self.skiftglad  = True
                            self.glad       = 100-self.glad
                        

                # Regel 7: Favoriser korte hopp. Hvis kort hopp, gi hyere score
                if self.benyttregel[7]:
                    for x in range(len(nyenoter)):
                        if (abs(nyenoter[x])>12):
                            vekt = [0]
                        else:
                            vekt = fzRule(int(round(abs(nyenoter[x]))),self.korthopp,self.scorevekt)
                        notescore[x] = notescore[x]*(1+max(vekt))*self.regelvekt[7]


                # Regel 8: Favoriser ulike noter (hvis "note er lik som forrige" gi mindre score)
                if self.benyttregel[8]:
                    for x in range(len(nyenoter)):
                        if(int(round(nyenoter[x])) == 0):
                            notescore[x] = notescore[x]/self.regelvekt[8]


                # Regel 9: Hvis tonen er utenfor toneleiet sett score lik 0
                for x in range(len(nyenoter)):
                    if(forrigenote + int(round(nyenoter[x])) > 127) or (forrigenote + int(round(nyenoter[x]))<0):
                        notescore[x] = 0
                        


                ###### Temporegler   #####
                #index           0       1     2   3  4
                #                1       2     4   8  16
                # oppdelinger   [0.125, 0.25, 0.5, 1, 2 ]
                currentIndex= self.tempoindex       # Index(i self.tempoliste) til det tempoet som spilles n
                self.forrigetempoindex = self.tempoindex
                # Regel 10: Hvis rolig spill saktere
                if self.benyttregel[10]:
                    scoreverdi = max(fzRule((self.rolig/10.0), self.errolig, self.spilltregere))*self.regelvekt[10]
                    index = int(round(fzFind(self.spilltregere,self.rolig/100.0)))
                    currentIndex = currentIndex + (index-currentIndex)*scoreverdi

                # Regel 11: Hvis glad, spill mer deltoner
                if self.benyttregel[11]:
                    scoreverdi = max(fzRule((self.glad/10.0), self.erglad, self.merdeltoner))*self.regelvekt[11]
                    index = int(round(fzFind(self.merdeltoner,self.glad/100.0)))
                    currentIndex = currentIndex + (index-self.tempoindex)*scoreverdi #*self.tempoparad

                # Regel 13: Favoriser variasjon
                #if self.benyttregel[13]:
                #    currentindex == self.forrigetempoindex 

                if self.benyttregel[15]:
                    self.tempoindex = int(round(currentIndex))

                # Regel 12: Kun lov med hele takter (dvs antall deltoner m g opp i 8/8)
                if self.benyttregel[12]:
                    tt = self.spilltick%16
                    if self.tempoindex==4 and tt != 0:
                        self.tempoindex= 3
                    if self.tempoindex==3 and tt%8 != 0:
                        self.tempoindex= 2
                    if self.tempoindex==2 and tt%4 != 0:
                        self.tempoindex= 1
                    if self.tempoindex==1 and tt%2 != 0:
                        self.tempoindex= 0

                sleep = (1/(self.tempo/60.0))*self.tempoliste[self.tempoindex]

                ## Litt debughjelpemiddler for  skrive ut listene. Skriver ikke ut nr False
                if False:
                    for x in nyenoter:
                        print round(x,3),
                    print ''
                    for x in notescore:
                        print round(x,3),
                    print ''
                    for x in nyenoter:
                        print lovligenoter[(forrigenote+int(round(x)))%12],
                    print ''


                ## Spiller av noten
                ## Velger den noten i nyenoter som har hyest verdi og samtidig er en lovlig note
                if self.benyttregel[15]:
                    self.noten = forrigenote
                    for x in range(len(nyenoter)):
                        testindex = notescore.index(max(notescore))
                        testn = forrigenote + int(round(nyenoter[testindex]))
                        if(lovligenoter[testn%12]):
                            self.noten = testn
                            break
                        else:
                            nyenoter.pop(testindex)
                            notescore.pop(testindex)

                if self.lagmusikk:
                    if self.benyttregel[15]:
                        print self.spilltick,'Spiller noten ', self.noten, 'lengde', round(sleep,3)

                if self.spill and self.lagmusikk and self.spilltrommer:
                    if self.spilltick<0:
                        if self.spilltick%8==0:
                            self.csound.inputMessage("i22   0 %(lengde)f 2000"%{'lengde':self.attedel})
                    else:
                        if self.spilltick%4==0:
                            self.csound.inputMessage("i21   0 %(lengde)f 2000"%{'lengde':self.attedel})
                        if self.spilltick%16==0:
                            self.csound.inputMessage("i22   0 %(lengde)f 1000"%{'lengde':self.attedel})
                        elif self.spilltick%16==8:
                            self.csound.inputMessage("i25   0 %(lengde)f 500"%{'lengde':self.attedel})


                if self.benyttregel[15]:
                    self.nynotetid += 2**self.tempoindex
                    if self.spill and self.lagmusikk:
                        self.csound.inputMessage("i 1 0 %(lengde)f 0.25 %(note)i 0 1"%{'lengde':sleep,'note':self.noten})
                    self.historie.append(self.noten)
                #else:
                #    print self.tick

                # For  lage score fil:
                if(self.makescore):
                    self.sco.append("i 1 %(st)f %(lengde)f %(note)i 70"%\
                                        {'st':self.starte, 'lengde':round(sleep,2),'note':self.noten})
                    self.starte += round(sleep,2)

                if self.tempoindex == self.forrigetempoindex:
                    self.tempoparad +=self.tempoindex
                else:
                    self.tempoparad = 1
                self.spilltick +=1
                time.sleep(self.tick)


        #Metode for  starte showet
        def run(self):
            print 'starter musikkmak'
            self.vis()
            while (True):
                if self.lagmusikk:
                    self.bestemnote()
                else:
                    if(self.avslutt):
                        print 'avslutter musmak traden'
                        return
                    else:
                        time.sleep(0.25)

        #Metode for  stoppe avspilling
        def stopp(self):
            self.lagmusikk = False
            if(self.spill):
                self.csound.stop()
            print '-------------------------Avspilte noter--------------------------------'
            print self.historie
            if(self.makescore):
                for x in self.sco:
                    print x
